﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Xml;
using System.Text;


namespace ASP.NET
{
    public partial class _Default : System.Web.UI.Page
    {
        private string TableToXml(DataTable DtTable)
        {
            StringBuilder PrintStr = new StringBuilder();
            XmlWriterSettings setting = new XmlWriterSettings();
            setting.Indent = true;
            setting.OmitXmlDeclaration = true;

            using (XmlWriter PrintXml = XmlWriter.Create(PrintStr, setting))
            {
                PrintXml.WriteStartElement("xml");
                PrintXml.WriteAttributeString("xmlns", "s", null, "u");
                PrintXml.WriteAttributeString("xmlns", "dt", null, "u");
                PrintXml.WriteAttributeString("xmlns", "rs", null, "u");
                PrintXml.WriteAttributeString("xmlns", "z", null, "#R");
                PrintXml.WriteStartElement("s", "Schema", null);
                PrintXml.WriteAttributeString("id", "RowsetSchema");
                PrintXml.WriteStartElement("s", "ElementType", null);
                PrintXml.WriteAttributeString("name", "row");
                PrintXml.WriteAttributeString("content", "eltOnly");
                PrintXml.WriteAttributeString("rs", "updatable", null, "true");

                foreach (DataColumn Column in DtTable.Columns)
                {
                    if (Column.DataType.Name == "Int64" || Column.DataType.Name == "Boolean"
                        || Column.DataType.Name == "String" || Column.DataType.Name == "DateTime"
                        || Column.DataType.Name == "Decimal" || Column.DataType.Name == "Double"
                        || Column.DataType.Name == "Int32" || Column.DataType.Name == "Single"
                        || Column.DataType.Name == "Int16" || Column.DataType.Name == "Byte")
                    {
                        PrintXml.WriteStartElement("s", "AttributeType", null);
                        PrintXml.WriteAttributeString("name", Column.ColumnName);

                        PrintXml.WriteAttributeString("rs", "number", null, (Column.Ordinal + 1).ToString());
                        PrintXml.WriteAttributeString("rs", "nullable", null, "true");
                        PrintXml.WriteAttributeString("rs", "maydefer", null, "true");
                        PrintXml.WriteAttributeString("rs", "writeunknown", null, "true");
                        PrintXml.WriteAttributeString("rs", "basetable", null, DtTable.TableName);
                        PrintXml.WriteAttributeString("rs", "basecolumn", null, Column.ColumnName);

                        if (Column.DataType.Name == "Int64")
                        {  //bigint
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "i8");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "8");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Boolean")
                        {  //bit
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "boolean");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "2");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "String")
                        {  //char
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "string");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, Column.MaxLength.ToString());
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "DateTime")
                        {  //dateTime
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "dateTime");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "16");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Decimal")
                        {  //Decimal
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "number");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "19");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Double")
                        {  //Float
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "float");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "8");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Int32")
                        {  //int
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "int");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "4");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Single")
                        {  //Real
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "r4");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "4");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Int16")
                        {  //smallint
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "i2");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "2");
                            PrintXml.WriteEndElement();
                        }
                        else if (Column.DataType.Name == "Byte")
                        {  //tinyint
                            PrintXml.WriteStartElement("s", "datatype", null);
                            PrintXml.WriteAttributeString("dt", "type", null, "ui1");
                            PrintXml.WriteAttributeString("dt", "maxLength", null, "1");
                            PrintXml.WriteEndElement();
                        }
                        PrintXml.WriteEndElement();
                    }
                }
                PrintXml.WriteEndElement();
                PrintXml.WriteEndElement();


                PrintXml.WriteStartElement("rs", "data", null);
                foreach (DataRow Row in DtTable.Rows)
                {
                    PrintXml.WriteStartElement("z", "row", null);
                    foreach (DataColumn Column in DtTable.Columns)
                    {
                        if (Row.IsNull(Column) == true)
                            continue;

                        if (Column.DataType.Name == "Int64" || Column.DataType.Name == "Boolean"
                            || Column.DataType.Name == "String" || Column.DataType.Name == "DateTime"
                            || Column.DataType.Name == "Decimal" || Column.DataType.Name == "Double"
                            || Column.DataType.Name == "Int32" || Column.DataType.Name == "Single"
                            || Column.DataType.Name == "Int16" || Column.DataType.Name == "Byte")
                        {
                            if (Column.DataType.Name == "DateTime")
                            {
                                DateTime TmpDateTime = System.Convert.ToDateTime(Row[Column]);
                                string TmpStr = TmpDateTime.ToString("yyyy-MM-dd") + "T" + TmpDateTime.ToString("HH:mm:ss");
                                PrintXml.WriteAttributeString(Column.ColumnName, TmpStr);
                            }
                            else
                            {
                                PrintXml.WriteAttributeString(Column.ColumnName, Row[Column].ToString());
                            }
                        }
                    }
                    PrintXml.WriteEndElement();
                }
                PrintXml.WriteEndElement();

                PrintXml.WriteEndElement();
            }

            return PrintStr.ToString();
        }

        private string FileToString(string FileName)
        {
            string[] ByteStr = new string[256];
            for (int i = 0; i < 256; i++)
            {
                if (i == 0)
                    ByteStr[i] = "00";
                else if (i < 16)
                    ByteStr[i] = "0" + Convert.ToString(i, 16).ToUpper();
                else
                    ByteStr[i] = Convert.ToString(i, 16).ToUpper();
            }

            if (File.Exists(Server.MapPath(FileName)) == false)
                return "";

            byte[] FileValue = File.ReadAllBytes(Server.MapPath(FileName));
            StringBuilder FileStr = new StringBuilder();

            for (int FileRecn = 0; FileRecn < FileValue.Length; FileRecn++)
            {
                FileStr.Append(ByteStr[FileValue[FileRecn]]);
            }
            FileValue = null;

            return FileStr.ToString();
        }

        private string TablePictureToStr(DataTable DtTable, string PictureFieldName)
        {
            string ScriptPicture = "";
            string FieldValue, PictureName, PictureValue;

            foreach (DataRow Row in DtTable.Rows)
            {
                FieldValue = Row[PictureFieldName].ToString().Trim();
                if (FieldValue == "")
                    continue;

                PictureName = ".\\Image\\" + FieldValue;
                if (File.Exists(Server.MapPath(PictureName)) == false)
                    continue;

                PictureValue = FileToString(PictureName);

                ScriptPicture = ScriptPicture + "ObjPrintMange.SavePictureFile('" + FieldValue + "' , '" + PictureValue + "' );";  //读取图片文件至打印控件，参数：文件名，该文件内容
            }
            return ScriptPicture;
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void BtnDepositPreview_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + " ObjPrintMange.PrintURL='http://www.xinyuerj.com/ASPPost/PrintNum.asp?FileName=DepsitAmt.fr3'; "
                     + " ObjPrintMange.PageSetURL='http://www.xinyuerj.com/ASPPost/PageSet.asp?FileName=DepsitAmt.fr3'; "
                     + " ObjPrintMange.LeftMargin=25;"
                     + " ObjPrintMange.RightMargin=10;"
                     + " ObjPrintMange.TopMargin=10;"
                     + " ObjPrintMange.BottomMargin=10;"
                    + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);
        }

        protected void BtnDepositPrint_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + "ObjPrintMange.PrintReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; window.location='./Default.aspx'; } </script>";  //window.location转向新的网页
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);
        }

        protected void BtnMasterPreview_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue1, PrintValue2, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\InInfo.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();


            DataSet DsInInfo = new DataSet();
            SqlDataAdapter DaInInfo = new SqlDataAdapter("Select * From InInfo", ConPrintTest);
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InInfo");
            DaInInfo.Fill(DsInInfo, "InInfo");
            DaInInfo.SelectCommand.CommandText = "Select * From InMaterial";
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InMaterial");
            DaInInfo.Fill(DsInInfo, "InMaterial");

            PrintValue1 = TableToXml(DsInInfo.Tables["InInfo"]);
            PrintValue2 = TableToXml(DsInInfo.Tables["InMaterial"]);

            DsInInfo.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + "ObjPrintMange.MasterOptions(1, 'InNo', 0 );"   //主从关系，参数：主数据集序号，关联字段名，字段是否为数值型
                     + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue1 + "', '"
                     + PrintValue2 + "', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);
        }

        protected void BtnPicturePreview_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;
            string PictureStr;

            FileValue = FileToString(".\\Frp\\Material.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsMaterial = new DataSet();
            SqlDataAdapter DaMaterial = new SqlDataAdapter("Select * From MaterialInfo", ConPrintTest);
            DaMaterial.FillSchema(DsMaterial, SchemaType.Source, "MaterialInfo");
            DaMaterial.Fill(DsMaterial, "MaterialInfo");

            PrintValue = TableToXml(DsMaterial.Tables["MaterialInfo"]);
            PictureStr = TablePictureToStr(DsMaterial.Tables["MaterialInfo"], "PictureFile"); //数据表中图片

            DsMaterial.Dispose();
            ConPrintTest.Close();

            string PictureFile, PictureValue;

            PictureFile = "Title.bmp";
            PictureValue = FileToString(".\\Image\\" + PictureFile);
            PictureStr = PictureStr + "ObjPrintMange.SavePictureFile('" + PictureFile + "' , '" + PictureValue + "' );";    //单个图片


            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + PictureStr
                     + "ObjPrintMange.AddPicturePrint('PicTitle', 0, 'Title.bmp','1', 1 );"       //增加单个图片打印，参数：报表中图片对象名，数据表的字段（为0），图片文件名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + "ObjPrintMange.AddPicturePrint('PicMaterial', 1, 'PictureFile','1', 0 );"  //增加数据表中的图片打印，参数：报表中图片对象名，数据表的字段（为1），图片文件名所对应的字段名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);
        }

        protected void BtnDepsitAmtDesign_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + " ObjPrintMange.ReportFileName='DepositAmt.fr3'; "
                     //+ " ObjPrintMange.DataSetName1='收银明细记录'; "
                     + " ObjPrintMange.DesignReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnMasterDesign_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue1, PrintValue2, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\InInfo.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();


            DataSet DsInInfo = new DataSet();
            SqlDataAdapter DaInInfo = new SqlDataAdapter("Select * From InInfo", ConPrintTest);
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InInfo");
            DaInInfo.Fill(DsInInfo, "InInfo");
            DaInInfo.SelectCommand.CommandText = "Select * From InMaterial";
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InMaterial");
            DaInInfo.Fill(DsInInfo, "InMaterial");

            PrintValue1 = TableToXml(DsInInfo.Tables["InInfo"]);
            PrintValue2 = TableToXml(DsInInfo.Tables["InMaterial"]);

            DsInInfo.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + "ObjPrintMange.MasterOptions(1, 'InNo', 0 );"   //主从关系，参数：主数据集序号，关联字段名，字段是否为数值型
                     + " ObjPrintMange.ReportFileName='InInfo.fr3'; "
                     + " ObjPrintMange.DesignReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue1 + "', '"
                     + PrintValue2 + "', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnPictureDesign_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;
            string PictureStr;

            FileValue = FileToString(".\\Frp\\Material.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsMaterial = new DataSet();
            SqlDataAdapter DaMaterial = new SqlDataAdapter("Select * From MaterialInfo", ConPrintTest);
            DaMaterial.FillSchema(DsMaterial, SchemaType.Source, "MaterialInfo");
            DaMaterial.Fill(DsMaterial, "MaterialInfo");

            PrintValue = TableToXml(DsMaterial.Tables["MaterialInfo"]);
            PictureStr = TablePictureToStr(DsMaterial.Tables["MaterialInfo"], "PictureFile"); //数据表中图片

            DsMaterial.Dispose();
            ConPrintTest.Close();

            string PictureFile, PictureValue;

            PictureFile = "Title.bmp";
            PictureValue = FileToString(".\\Image\\" + PictureFile);
            PictureStr = PictureStr + "ObjPrintMange.SavePictureFile('" + PictureFile + "' , '" + PictureValue + "' );";    //单个图片


            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + PictureStr
                     + "ObjPrintMange.AddPicturePrint('PicTitle', 0, 'Title.bmp','1', 1 );"       //增加单个图片打印，参数：报表中图片对象名，数据表的字段（为0），图片文件名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + "ObjPrintMange.AddPicturePrint('PicMaterial', 1, 'PictureFile','1', 0 );"  //增加数据表中的图片打印，参数：报表中图片对象名，数据表的字段（为1），图片文件名所对应的字段名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + " ObjPrintMange.ReportFileName='Material.fr3'; "
                     + " ObjPrintMange.DesignReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnDepositPreviewD_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckDomainName('xinyuerj.com', 'EDBA735B16AC156AABC7C99EB34409DA'); "  //注册码
                     + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnDepositPrintD_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckDomainName('xinyuerj.com', 'EDBA735B16AC156AABC7C99EB34409DA'); "  //注册码
                     + "ObjPrintMange.PrintReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; window.location='./Default.aspx'; } </script>";  //window.location转向新的网页
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnMasterPreviewD_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue1, PrintValue2, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\InInfo.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();


            DataSet DsInInfo = new DataSet();
            SqlDataAdapter DaInInfo = new SqlDataAdapter("Select * From InInfo", ConPrintTest);
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InInfo");
            DaInInfo.Fill(DsInInfo, "InInfo");
            DaInInfo.SelectCommand.CommandText = "Select * From InMaterial";
            DaInInfo.FillSchema(DsInInfo, SchemaType.Source, "InMaterial");
            DaInInfo.Fill(DsInInfo, "InMaterial");

            PrintValue1 = TableToXml(DsInInfo.Tables["InInfo"]);
            PrintValue2 = TableToXml(DsInInfo.Tables["InMaterial"]);

            DsInInfo.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckDomainName('xinyuerj.com', 'EDBA735B16AC156AABC7C99EB34409DA'); "  //注册码
                     + "ObjPrintMange.MasterOptions(1, 'InNo', 0 );"   //主从关系，参数：主数据集序号，关联字段名，字段是否为数值型
                     + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue1 + "', '"
                     + PrintValue2 + "', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnPicturePreviewD_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;
            string PictureStr;

            FileValue = FileToString(".\\Frp\\Material.fr3");
            ParaName = "ShopName";  //`~为各参数的分隔符
            ParaValue = "测试酒楼";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsMaterial = new DataSet();
            SqlDataAdapter DaMaterial = new SqlDataAdapter("Select * From MaterialInfo", ConPrintTest);
            DaMaterial.FillSchema(DsMaterial, SchemaType.Source, "MaterialInfo");
            DaMaterial.Fill(DsMaterial, "MaterialInfo");

            PrintValue = TableToXml(DsMaterial.Tables["MaterialInfo"]);
            PictureStr = TablePictureToStr(DsMaterial.Tables["MaterialInfo"], "PictureFile"); //数据表中图片

            DsMaterial.Dispose();
            ConPrintTest.Close();

            string PictureFile, PictureValue;

            PictureFile = "Title.bmp";
            PictureValue = FileToString(".\\Image\\" + PictureFile);
            PictureStr = PictureStr + "ObjPrintMange.SavePictureFile('" + PictureFile + "' , '" + PictureValue + "' );";    //单个图片


            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckDomainName('xinyuerj.com', 'EDBA735B16AC156AABC7C99EB34409DA'); "  //注册码
                     + PictureStr
                     + "ObjPrintMange.AddPicturePrint('PicTitle', 0, 'Title.bmp','1', 1 );"       //增加单个图片打印，参数：报表中图片对象名，数据表的字段（为0），图片文件名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + "ObjPrintMange.AddPicturePrint('PicMaterial', 1, 'PictureFile','1', 0 );"  //增加数据表中的图片打印，参数：报表中图片对象名，数据表的字段（为1），图片文件名所对应的字段名，数据集序号，是否清除旧数据（第1次调用时为1，其它时候则为0）
                     + "ObjPrintMange.ShowReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnDepsitAmtDesignPost_Click(object sender, EventArgs e)
        {
            string FileValue, PrintValue, ParaName, ParaValue;

            FileValue = FileToString(".\\Frp\\DepositAmt.fr3");
            ParaName = "ShopName`~PrintDepositAdd`~PrintPaperNo`~Title";  //`~为各参数的分隔符
            ParaValue = "测试酒楼"
                      + "`~说明：本单据为贵客押金收取凭证，盖章有效。退房时请出示，遗失者自负，请妥善保存。退房时间为12:00时，延时退房18:00时以前按半天房费收取，18:00时以后算全天房价。押金单有效期为一个月，过期作废。       贵重物品请交前台寄存，未寄存丢失自负。      谢谢！"
                      + "`~身份证：4325011980639512"
                      + "`~押金单";

            SqlConnection ConPrintTest = new SqlConnection(ConfigurationManager.ConnectionStrings["PrintTestConnectionString"].ToString());
            ConPrintTest.Open();
            DataSet DsCashLog = new DataSet();
            SqlDataAdapter DaCashLog = new SqlDataAdapter("Select top 1 CashNo, CashDate, CashAmt, PayName, GuestName, RoomNo, ItemRemark, CashUserName, Remark From CashLog", ConPrintTest);
            DaCashLog.FillSchema(DsCashLog, SchemaType.Source, "CashLog");
            DaCashLog.Fill(DsCashLog, "CashLog");

            PrintValue = TableToXml(DsCashLog.Tables["CashLog"]);

            DsCashLog.Dispose();
            ConPrintTest.Close();

            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + " ObjPrintMange.ReportFileName='DepositAmt.fr3'; "
                     + " ObjPrintMange.PostURL='http://www.xinyuerj.com/ASPPost/Show.asp?FileName=DepsitAmt.fr3'; "
                     + " ObjPrintMange.DesignReport('"
                     + FileValue + "' , '"
                     + ParaName + "', '"
                     + ParaValue + "', '"
                     + PrintValue + "', '', '', '', '', '');"
                     + "ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }

        protected void BtnPrinterList_Click(object sender, EventArgs e)
        {
            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + " var ObjCmbPrinterList = document.getElementById('CmbPrinterList');"
                     + " var strPrinterList = ObjPrintMange.PrinterList; "
                     + " var arrayPrinterList = strPrinterList.split(';'); "
                     + " ObjCmbPrinterList.innerHTML = ''; "
                     + " for (var i = 0; i < arrayPrinterList.length-1; i++) { "
                     + " ObjCmbPrinterList[i] = new Option(arrayPrinterList[i], 0); }"
                     + " ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);
        }

        protected void BtnPrintCOM_Click(object sender, EventArgs e)
        {
            string ScriptStr;

            ScriptStr = "<script language='javascript'>window.onload = function() { try { var ObjPrintMange =  new ActiveXObject('WebPrint.WebPrintUnit'); } catch(e) { if( confirm('打印控件未安装，现在下载吗?') ) { window.location='./PrintActivex.exe'; } return; } var OldVersion=ObjPrintMange.Version; NewVerion='5.0(2011-08-01)'; if(OldVersion < NewVerion) { ObjPrintMange = null; alert('打印控件需升级。请先进行下载，下载后关闭IE，然后安装升级版。'); window.location='./PrintActivex.exe'; return;  } "
                     + " ObjPrintMange.CheckReg('公司名称', '3B8E5B998A3125EE89983EA940BB2AEE'); "  //注册码
                     + " ObjPrintMange.ComName = 'COM1'; "  //端口号，LPT1为并口1，COM1为串口1
                     + " ObjPrintMange.BaudRate = 9600; "   //串口波特率，默认9600 
                     + " ObjPrintMange.Stopbits = 0; "      //停止位，默认为ONESTOPBIT = 0, ONE5STOPBITS = 1, TWOSTOPBITS = 2  
                     + " ObjPrintMange.Bytesize = 8; "      //数据位长度，默认为8
                     + " ObjPrintMange.TimeOut = 3000; "    //数据发送超时，串口则为写一个数据位的超时，并口的超时为整个数据的传送时间，默认为3000毫秒
                     + " ObjPrintMange.isCheckPrint = 0; "  //串口打印时是否检测打印机状态（标准EPSON或仿EPSON打印机有效），默认为0
                     + " strData=String.fromCharCode(27)+document.getElementById('T1').value; "
                     + " Result = ObjPrintMange.WriteComData(strData); " //写数据，返回值：0表示成功，-1表示端口打开失败，-2表示数据发送失败，-3表示打印机故障
                     + " if( Result == 0 ) alert('写端口成功！'); "
                     + " else alert('写端口失败！失败原因：' + Result); "
                     + " ObjPrintMange = null; } </script>";
            ScriptStr = ScriptStr.Replace(System.Environment.NewLine, string.Empty);

            Response.Write(ScriptStr);

        }
    }
}
